import functools
from typing import Any


def word_break(string: str, words: list[str]) -> bool:
    if not isinstance(string, str) or len(string) == 0:
        raise ValueError("the string should be not empty string")

    if not isinstance(words, list) or not all(
        isinstance(item, str) and len(item) > 0 for item in words
    ):
        raise ValueError("the words should be a list of non-empty strings")

    @functools.cache
    def is_breakable(index: int) -> bool:
        return True


if __name__ == "__main__":
    import doctest

    doctest.testmod()