from pathlib import Path

from .fp_method_builder import FingerprintMethodBuilder
from .fragments import create_fragments, generate_str_code_from_file
from .method_configurator import MethodConfigurator


def main():
    filenames = ['./clonus/Tests/Python/[1]bitmask.py', './clonus/Tests/Python/[2]bitmask.py', './clonus/Tests/Python/[3]bitmask.py']
    fp_builder = FingerprintMethodBuilder(filenames)
    config = MethodConfigurator(fp_builder)
    res = config.make_method()
    file1 = generate_str_code_from_file(Path('./clonus/Tests/Python/[1]bitmask.py'))
    file2 = generate_str_code_from_file(Path('./clonus/Tests/Python/[2]bitmask.py'))
    #all_fragments = create_fragments(file1, file2, res.clone_parts_1, res.clone_parts_2, filenames[0].split('/')[-1], filenames[1].split('/')[-1],)
    #print(all_fragments)

main()
